Imports System.Data.SqlClient

'\\ --[Form_DocumentCategories]---------------------------------------------
'\\ The form that manages the document categorisation process parameters
'\\ (c) 2005 - Merrion Computing Ltd
'\\ ------------------------------------------------------------------------

Public Class Form_DocumentCategories
    Inherits System.Windows.Forms.Form

#Region "Private members"
    Private _DBConn As SqlConnection
#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        '\\ Connect to the database....
        Try
            _DBConn = New SqlConnection(My.Settings.ConnectionString)
        Catch e As Exception
            If Puma_Manager_Application.ApplicationTracing.TraceError Then
                Trace.WriteLine(e.ToString, Me.GetType.ToString)
            End If
        End Try

        Call RefreshCategoryTypes()

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label_Category_Type As System.Windows.Forms.Label
    Friend WithEvents ComboBox_Category_Types As System.Windows.Forms.ComboBox
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    Friend WithEvents ContextMenu_DocCategories As System.Windows.Forms.ContextMenu
    Friend WithEvents MenuItem_Add_New As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem_Delete As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem_Modify As System.Windows.Forms.MenuItem
    Friend WithEvents Button_Close As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label_Category_Type = New System.Windows.Forms.Label
        Me.ComboBox_Category_Types = New System.Windows.Forms.ComboBox
        Me.DataGrid1 = New System.Windows.Forms.DataGrid
        Me.ContextMenu_DocCategories = New System.Windows.Forms.ContextMenu
        Me.MenuItem_Add_New = New System.Windows.Forms.MenuItem
        Me.MenuItem_Delete = New System.Windows.Forms.MenuItem
        Me.MenuItem_Modify = New System.Windows.Forms.MenuItem
        Me.Button_Close = New System.Windows.Forms.Button
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label_Category_Type
        '
        Me.Label_Category_Type.Location = New System.Drawing.Point(8, 8)
        Me.Label_Category_Type.Name = "Label_Category_Type"
        Me.Label_Category_Type.Size = New System.Drawing.Size(80, 16)
        Me.Label_Category_Type.TabIndex = 0
        Me.Label_Category_Type.Text = "Category Type"
        '
        'ComboBox_Category_Types
        '
        Me.ComboBox_Category_Types.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.ComboBox_Category_Types.ItemHeight = 13
        Me.ComboBox_Category_Types.Location = New System.Drawing.Point(88, 8)
        Me.ComboBox_Category_Types.Name = "ComboBox_Category_Types"
        Me.ComboBox_Category_Types.Size = New System.Drawing.Size(392, 21)
        Me.ComboBox_Category_Types.TabIndex = 1
        '
        'DataGrid1
        '
        Me.DataGrid1.ContextMenu = Me.ContextMenu_DocCategories
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid1.Location = New System.Drawing.Point(8, 32)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.PreferredColumnWidth = 170
        Me.DataGrid1.ReadOnly = True
        Me.DataGrid1.Size = New System.Drawing.Size(472, 232)
        Me.DataGrid1.TabIndex = 2
        '
        'ContextMenu_DocCategories
        '
        Me.ContextMenu_DocCategories.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem_Add_New, Me.MenuItem_Delete, Me.MenuItem_Modify})
        '
        'MenuItem_Add_New
        '
        Me.MenuItem_Add_New.Index = 0
        Me.MenuItem_Add_New.Text = "&Add new"
        '
        'MenuItem_Delete
        '
        Me.MenuItem_Delete.Index = 1
        Me.MenuItem_Delete.Text = "&Delete"
        '
        'MenuItem_Modify
        '
        Me.MenuItem_Modify.Index = 2
        Me.MenuItem_Modify.Text = "&Modify"
        '
        'Button_Close
        '
        Me.Button_Close.Location = New System.Drawing.Point(416, 272)
        Me.Button_Close.Name = "Button_Close"
        Me.Button_Close.Size = New System.Drawing.Size(64, 24)
        Me.Button_Close.TabIndex = 4
        Me.Button_Close.Text = "&Close"
        '
        'Form_DocumentCategories
        '
        Me.AcceptButton = Me.Button_Close
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(488, 301)
        Me.ControlBox = False
        Me.Controls.Add(Me.Button_Close)
        Me.Controls.Add(Me.DataGrid1)
        Me.Controls.Add(Me.ComboBox_Category_Types)
        Me.Controls.Add(Me.Label_Category_Type)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form_DocumentCategories"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Document Categorisation"
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Button_Close_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button_Close.Click
        Me.Hide()
    End Sub

    Private Sub Form_DocumentCategories_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed

        If _DBConn.State = ConnectionState.Open Then
            _DBConn.Close()
        End If

    End Sub

#Region "RefreshCategoryTypes"
    Private Sub RefreshCategoryTypes()

        If Puma_Manager_Application.ApplicationTracing.TraceVerbose Then
            Trace.WriteLine("RefreshCategoryTypes")
        End If

        Me.ComboBox_Category_Types.Items.Clear()

        If _DBConn.State = ConnectionState.Closed Then
            _DBConn.Open()
        End If

        Dim sqlcmdCategoryTypes As New SqlCommand("SELECT DISTINCT [Data Element Value] FROM [Reference Data] WHERE [Data Element Name] = 'Document Category Type'", _DBConn)
        Dim CategoryTypesReader As SqlDataReader = sqlcmdCategoryTypes.ExecuteReader

        Try
            While CategoryTypesReader.Read
                ComboBox_Category_Types.Items.Add(CategoryTypesReader.GetString(0))
            End While
        Catch e As Exception
            If Puma_Manager_Application.ApplicationTracing.TraceError Then
                Trace.WriteLine(e.ToString, Me.GetType.ToString)
            End If
        End Try

        CategoryTypesReader.Close()
        _DBConn.Close()

    End Sub
#End Region

#Region "RefreshAutomaticDocumentCategorisation"
    Private Sub RefreshAutomaticDocumentCategorisation(ByVal CategoryType As String)

        If Puma_Manager_Application.ApplicationTracing.TraceVerbose Then
            Trace.WriteLine("RefreshAutomaticDocumentCategorisation")
        End If

        If CategoryType Is Nothing Then
            Exit Sub
        End If

        If _DBConn.State = ConnectionState.Closed Then
            _DBConn.Open()
        End If

        Dim sqlCmd As New SqlCommand("SELECT * FROM [Automatic Document Categorisation] WHERE [Category Type] = '" & CategoryType & "'", _DBConn)
        Dim adapter As New SqlDataAdapter(sqlCmd)
        Dim dt As New DataTable
        adapter.Fill(dt)

        Me.DataGrid1.SetDataBinding(dt, "")

    End Sub
#End Region


    Private Sub ComboBox_Category_Types_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_Category_Types.SelectedIndexChanged
        Call RefreshAutomaticDocumentCategorisation(ComboBox_Category_Types.SelectedItem)
    End Sub


    Private Sub MenuItem_Add_New_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MenuItem_Add_New.Click
        Dim fDialog As New Form_DocumentCategory
        fDialog.SetSelectedCategory(Me.ComboBox_Category_Types.Text)
        fDialog.ShowDialog(Me)
        Call RefreshAutomaticDocumentCategorisation(Me.ComboBox_Category_Types.Text)
    End Sub


    Private Sub MenuItem_Modify_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MenuItem_Modify.Click

        If Me.DataGrid1.CurrentRowIndex > -1 Then
            Dim fDialog As New Form_DocumentCategory
            '\\ Set it to the selected document category
            fDialog.SetSelectedCategory(Me.ComboBox_Category_Types.Text, Me.SelectedCategroy)
            fDialog.ShowDialog(Me)
            Call RefreshAutomaticDocumentCategorisation(Me.ComboBox_Category_Types.Text)
        Else
            Beep()
        End If

    End Sub


    Private Sub MenuItem_Delete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MenuItem_Delete.Click

        If Me.DataGrid1.CurrentRowIndex > -1 Then
            If MessageBox.Show("Are you sure you want to delete this category definition?", "Warning", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                '\\ Delete the selected document category
                Dim sql As String
                sql = "EXECUTE Delete_Document_Category '" & Me.ComboBox_Category_Types.Text & "','" & Me.SelectedCategroy & "'"
                Try
                    If _DBConn.State = ConnectionState.Closed Then
                        _DBConn.Open()
                    End If
                    Dim cmd As New SqlCommand(sql, _DBConn)
                    cmd.ExecuteNonQuery()
                    _DBConn.Close()
                Catch ex As Exception
                    If Puma_Manager_Application.ApplicationTracing.TraceError Then
                        Trace.WriteLine(ex.ToString, Me.GetType.ToString)
                    End If
                End Try
            End If
            Call RefreshAutomaticDocumentCategorisation(Me.ComboBox_Category_Types.Text)
        Else
            Beep()
        End If

    End Sub

#Region "SelectedCategory"
    Private Function SelectedCategroy() As String
        If Me.DataGrid1.CurrentRowIndex > -1 Then
            Try
                Return DataGrid1.Item(DataGrid1.CurrentRowIndex, 1)
            Catch ex As Exception
                If Puma_Manager_Application.ApplicationTracing.TraceError Then
                    Trace.WriteLine(ex.ToString, Me.GetType.ToString)
                End If
                Return ""
            End Try
        Else
            Return ""
        End If
    End Function
#End Region
End Class
