Imports System.Data.SqlClient

Public Class Form_Manage_Reports
    Inherits System.Windows.Forms.Form

#Region "Private constants"
    Private Const PREVIEW_COUNT As String = "SELECT TOP 20  "
    Private _Reports As PrinterUsageReportsDictionary
    Private dt As New DataTable
    Private _ShowNew As Boolean
    Private _ShowModify As Boolean
    Private _SelectedReport As String
#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        Call RefreshReportList()

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ListBox_Reports As System.Windows.Forms.ListBox
    Friend WithEvents ContextMenu_Report_Management As System.Windows.Forms.ContextMenu
    Friend WithEvents MenuItem_New_Report As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem_Modify As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem_Delete As System.Windows.Forms.MenuItem
    Friend WithEvents Label_Report_Description As System.Windows.Forms.Label
    Friend WithEvents DataGrid_Report_Preview As System.Windows.Forms.DataGrid
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form_Manage_Reports))
        Me.ListBox_Reports = New System.Windows.Forms.ListBox
        Me.ContextMenu_Report_Management = New System.Windows.Forms.ContextMenu
        Me.MenuItem_New_Report = New System.Windows.Forms.MenuItem
        Me.MenuItem_Modify = New System.Windows.Forms.MenuItem
        Me.MenuItem_Delete = New System.Windows.Forms.MenuItem
        Me.Label_Report_Description = New System.Windows.Forms.Label
        Me.DataGrid_Report_Preview = New System.Windows.Forms.DataGrid
        CType(Me.DataGrid_Report_Preview, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'ListBox_Reports
        '
        Me.ListBox_Reports.AccessibleDescription = "List of the available printer usage reports"
        Me.ListBox_Reports.ContextMenu = Me.ContextMenu_Report_Management
        Me.ListBox_Reports.Location = New System.Drawing.Point(8, 8)
        Me.ListBox_Reports.Name = "ListBox_Reports"
        Me.ListBox_Reports.Size = New System.Drawing.Size(528, 147)
        Me.ListBox_Reports.TabIndex = 0
        '
        'ContextMenu_Report_Management
        '
        Me.ContextMenu_Report_Management.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem_New_Report, Me.MenuItem_Modify, Me.MenuItem_Delete})
        '
        'MenuItem_New_Report
        '
        Me.MenuItem_New_Report.Index = 0
        Me.MenuItem_New_Report.Text = "&New report"
        '
        'MenuItem_Modify
        '
        Me.MenuItem_Modify.Index = 1
        Me.MenuItem_Modify.Text = "&Modify"
        '
        'MenuItem_Delete
        '
        Me.MenuItem_Delete.Index = 2
        Me.MenuItem_Delete.Text = "&Delete"
        '
        'Label_Report_Description
        '
        Me.Label_Report_Description.Location = New System.Drawing.Point(8, 160)
        Me.Label_Report_Description.Name = "Label_Report_Description"
        Me.Label_Report_Description.Size = New System.Drawing.Size(528, 16)
        Me.Label_Report_Description.TabIndex = 1
        Me.Label_Report_Description.Text = "..."
        '
        'DataGrid_Report_Preview
        '
        Me.DataGrid_Report_Preview.DataMember = ""
        Me.DataGrid_Report_Preview.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid_Report_Preview.Location = New System.Drawing.Point(8, 184)
        Me.DataGrid_Report_Preview.Name = "DataGrid_Report_Preview"
        Me.DataGrid_Report_Preview.ReadOnly = True
        Me.DataGrid_Report_Preview.Size = New System.Drawing.Size(528, 152)
        Me.DataGrid_Report_Preview.TabIndex = 2
        '
        'Form_Manage_Reports
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(544, 341)
        Me.Controls.Add(Me.DataGrid_Report_Preview)
        Me.Controls.Add(Me.Label_Report_Description)
        Me.Controls.Add(Me.ListBox_Reports)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form_Manage_Reports"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Manage printer usage reports"
        CType(Me.DataGrid_Report_Preview, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Private methods"

    '\\ --[RefreshReportList]------------------------------------------
    '\\ List the reports currently held in the database
    '\\ ---------------------------------------------------------------
    Private Sub RefreshReportList()

        _Reports = New PrinterUsageReportsDictionary
        Me.ListBox_Reports.Items.Clear()
        Me.ListBox_Reports.BeginUpdate()
        For Each rs As PrinterUsageReport In _Reports.Values
            Me.ListBox_Reports.Items.Add(rs)
        Next
        Me.ListBox_Reports.EndUpdate()

    End Sub

    '\\ --[RefreshReportPreview]---------------------------------------
    '\\ Shows a preview of the selected report
    '\\ ---------------------------------------------------------------
    Private Sub RefreshReportPreview(ByVal QueryDef As String)

        Dim _dbConn As New SqlClient.SqlConnection(My.Settings.ConnectionString)

        If _dbConn.State <> ConnectionState.Open Then
            _dbConn.Open()
        End If

        If QueryDef.StartsWith("SELECT") Then
            QueryDef = PREVIEW_COUNT & QueryDef.Substring(7)
        Else
            QueryDef = PREVIEW_COUNT & QueryDef
        End If

        Dim sqlCmd As New SqlCommand(QueryDef, _dbConn)

        Dim adapter As New SqlDataAdapter(sqlCmd)
        dt.Clear()
        dt = New DataTable
        Try
            adapter.Fill(dt)
        Catch ex As Exception
            Exit Sub
        End Try

        Me.DataGrid_Report_Preview.SetDataBinding(dt, "")

    End Sub

#End Region

#Region "Public interface"

    Public ReadOnly Property ShowNew() As Boolean
        Get
            Return _ShowNew
        End Get
    End Property

    Public ReadOnly Property ShowModify() As Boolean
        Get
            Return _ShowModify
        End Get
    End Property

    Public ReadOnly Property SelectedReport() As String
        Get
            Return _SelectedReport
        End Get
    End Property

#End Region

#Region "Listbox event handlers"

    Private Sub ListBox_Reports_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListBox_Reports.SelectedValueChanged

        With CType(ListBox_Reports.SelectedItem, PrinterUsageReport)
            Me.Label_Report_Description.Text = .Description
            Call RefreshReportPreview(.QueryDef)
        End With
    End Sub

#End Region

#Region "Context menu handlers"

#Region "New"
    Private Sub MenuItem_New_Report_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MenuItem_New_Report.Click
        _ShowNew = True
        Me.Hide()
    End Sub
#End Region

#Region "Modify"
    Private Sub MenuItem_Modify_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MenuItem_Modify.Click
        _ShowModify = True
        If Not ListBox_Reports.SelectedItem Is Nothing Then
            _SelectedReport = CType(ListBox_Reports.SelectedItem, PrinterUsageReport).Name
        End If
        Me.Hide()
    End Sub
#End Region

#Region "Delete"
    Private Sub MenuItem_Delete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MenuItem_Delete.Click
        If MessageBox.Show("Are you sure you want to delete this report?", "Destructive action", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = Windows.Forms.DialogResult.Yes Then
            '\\ Delete the selected report
            PrinterUsageReportDefinition.DeleteReport(CType(ListBox_Reports.SelectedItem, PrinterUsageReport).Name)

            '\\ Refresh the list
            Call RefreshReportList()

        End If
    End Sub
#End Region
#End Region


End Class
