Public Class Form_DataGrid_Columns
    Inherits System.Windows.Forms.Form

#Region "Private properties"
    Private _Reordered As Boolean
    Private _DataGrid As DataGrid
#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents CheckedListBox_Columns As System.Windows.Forms.CheckedListBox
    Friend WithEvents Button_Move_Up As System.Windows.Forms.Button
    Friend WithEvents Button_Move_Down As System.Windows.Forms.Button
    Friend WithEvents Button_Cancel As System.Windows.Forms.Button
    Friend WithEvents Button_OK As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.CheckedListBox_Columns = New System.Windows.Forms.CheckedListBox
        Me.Button_Move_Up = New System.Windows.Forms.Button
        Me.Button_Move_Down = New System.Windows.Forms.Button
        Me.Button_Cancel = New System.Windows.Forms.Button
        Me.Button_OK = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'CheckedListBox_Columns
        '
        Me.CheckedListBox_Columns.Location = New System.Drawing.Point(8, 8)
        Me.CheckedListBox_Columns.Name = "CheckedListBox_Columns"
        Me.CheckedListBox_Columns.Size = New System.Drawing.Size(264, 244)
        Me.CheckedListBox_Columns.TabIndex = 0
        '
        'Button_Move_Up
        '
        Me.Button_Move_Up.Enabled = False
        Me.Button_Move_Up.Location = New System.Drawing.Point(280, 8)
        Me.Button_Move_Up.Name = "Button_Move_Up"
        Me.Button_Move_Up.Size = New System.Drawing.Size(48, 32)
        Me.Button_Move_Up.TabIndex = 1
        Me.Button_Move_Up.Text = "&Up"
        '
        'Button_Move_Down
        '
        Me.Button_Move_Down.Enabled = False
        Me.Button_Move_Down.Location = New System.Drawing.Point(280, 48)
        Me.Button_Move_Down.Name = "Button_Move_Down"
        Me.Button_Move_Down.Size = New System.Drawing.Size(48, 32)
        Me.Button_Move_Down.TabIndex = 2
        Me.Button_Move_Down.Text = "&Down"
        '
        'Button_Cancel
        '
        Me.Button_Cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Button_Cancel.Location = New System.Drawing.Point(192, 264)
        Me.Button_Cancel.Name = "Button_Cancel"
        Me.Button_Cancel.Size = New System.Drawing.Size(64, 32)
        Me.Button_Cancel.TabIndex = 3
        Me.Button_Cancel.Text = "&Cancel"
        '
        'Button_OK
        '
        Me.Button_OK.Location = New System.Drawing.Point(264, 264)
        Me.Button_OK.Name = "Button_OK"
        Me.Button_OK.Size = New System.Drawing.Size(64, 32)
        Me.Button_OK.TabIndex = 4
        Me.Button_OK.Text = "&OK"
        '
        'Form_DataGrid_Columns
        '
        Me.AcceptButton = Me.Button_OK
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.Button_Cancel
        Me.ClientSize = New System.Drawing.Size(336, 311)
        Me.ControlBox = False
        Me.Controls.Add(Me.Button_OK)
        Me.Controls.Add(Me.Button_Cancel)
        Me.Controls.Add(Me.Button_Move_Down)
        Me.Controls.Add(Me.Button_Move_Up)
        Me.Controls.Add(Me.CheckedListBox_Columns)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form_DataGrid_Columns"
        Me.Text = "Grid Columns Settings"
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Public interface"

    Public WriteOnly Property DataGrid() As DataGrid
        Set(ByVal Value As DataGrid)
            _DataGrid = Value
            Call RefreshForm()
        End Set
    End Property
#End Region

#Region "Private methods"
    Private Sub RefreshForm()

        Me.CheckedListBox_Columns.Items.Clear()
        For Each cs As DataGridColumnStyle In _DataGrid.TableStyles(0).GridColumnStyles
            CheckedListBox_Columns.Items.Add(cs.HeaderText)
            If cs.Width > 0 Then
                CheckedListBox_Columns.SetItemChecked(CheckedListBox_Columns.Items.Count - 1, True)
            End If
        Next

    End Sub
#End Region

#Region "Command button handlers"
    Private Sub Button_OK_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button_OK.Click

        '\\ Reorder the column styles according to the list
            Dim csArray(_DataGrid.TableStyles(0).GridColumnStyles.Count - 1) As DataGridColumnStyle
            _DataGrid.TableStyles(0).GridColumnStyles.CopyTo(csArray, 0)
            Dim TableStyle As New DataGridTableStyle
            TableStyle.MappingName = _DataGrid.TableStyles(0).MappingName

            For nItem As Integer = 0 To csArray.Length - 1
                For Each cs As DataGridColumnStyle In csArray
                    If cs.HeaderText = CheckedListBox_Columns.Items(nItem) Then
                        If CheckedListBox_Columns.GetItemChecked(nItem) = False Then
                            cs.Width = 0
                        Else
                            If cs.Width = 0 Then
                            cs.Width = _DataGrid.PreferredColumnWidth
                            End If
                        End If
                        TableStyle.GridColumnStyles.Add(cs)
                        Exit For
                    End If
                Next
            Next

        _DataGrid.TableStyles.Add(TableStyle)


        Me.DialogResult = DialogResult.OK
        Me.Hide()
    End Sub

    Private Sub Button_Move_Down_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button_Move_Down.Click
        _Reordered = True
        Dim Checked As Boolean = CheckedListBox_Columns.GetItemChecked(CheckedListBox_Columns.SelectedIndex)
        Dim MoveObject As Object = CheckedListBox_Columns.SelectedItem
        Dim NewPos As Integer = CheckedListBox_Columns.SelectedIndex + 2
        CheckedListBox_Columns.Items.Insert(NewPos, MoveObject)
        CheckedListBox_Columns.SetItemChecked(NewPos, Checked)
        CheckedListBox_Columns.Items.RemoveAt(CheckedListBox_Columns.SelectedIndex)

    End Sub

    Private Sub Button_Move_Up_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button_Move_Up.Click
        _Reordered = True
        Dim Checked As Boolean = CheckedListBox_Columns.GetItemChecked(CheckedListBox_Columns.SelectedIndex)
        Dim MoveObject As Object = CheckedListBox_Columns.SelectedItem
        Dim NewPos As Integer = CheckedListBox_Columns.SelectedIndex - 1
        CheckedListBox_Columns.Items.Insert(NewPos, MoveObject)
        CheckedListBox_Columns.SetItemChecked(NewPos, Checked)
        CheckedListBox_Columns.Items.RemoveAt(CheckedListBox_Columns.SelectedIndex)

    End Sub

#End Region

#Region "Checked List event handlers"
    Private Sub CheckedListBox_Columns_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckedListBox_Columns.SelectedIndexChanged

        If CheckedListBox_Columns.SelectedIndex > -1 Then
            Me.Button_Move_Up.Enabled = (CheckedListBox_Columns.SelectedIndex > 0)
            Me.Button_Move_Down.Enabled = (CheckedListBox_Columns.SelectedIndex < CheckedListBox_Columns.Items.Count - 1)
        Else
            Me.Button_Move_Up.Enabled = False
            Me.Button_Move_Down.Enabled = False
        End If

    End Sub
#End Region

End Class
