'\\ --[PrinterMonitorViewerMain]----------------------
'\\ Main module of the printer monitor viewer
'\\ --------------------------------------------------
Module PrinterMonitorViewerMain

#Region "Private members"
    Private _ConnectionString As String
#End Region

    Public Sub Main()

        Dim fViewer As New Form_PrinterUsageViewer
        Try
            fViewer.ShowDialog()
        Catch efrm As Exception
            If PrinterMonitorViewerApplication.ApplicationTracing.TraceError Then
                Trace.WriteLine(efrm.Message, "Form_PrinterUsageViewer")
            End If
        End Try
    End Sub


#Region "Utility functions"
    '\\ --[StripDomainFromFullUsername]------------------------------------------------
    '\\ Returns just the username bit from a username that includes a domain name
    '\\ e.g. "DEVELOPMENT\Duncan" -> "Duncan"
    '\\ (c) 2005 - Merrion Computing Ltd
    '\\ -------------------------------------------------------------------------------
    Public Function StripDomainFromFullUsername(ByVal FullUsername As String) As String

        If FullUsername.IndexOf("\") = -1 Then
            Return FullUsername
        Else
            Dim chaf() As String = FullUsername.Split("\")
            Return (chaf(chaf.Length - 1))
        End If

    End Function

    Public Function ConnectionString() As String

        If _ConnectionString = "" Then
            Dim configSettings As New System.Configuration.AppSettingsReader
            With configSettings
                Try
                    _ConnectionString = .GetValue("ConnectionString", GetType(System.String))
                Catch e As Exception
                    If PrinterMonitorViewerApplication.ApplicationTracing.TraceError Then
                        Trace.WriteLine("Failed to get database connection string from the configuration file", "Application")
                    End If
                    Throw e
                End Try
            End With
        End If

        Return _ConnectionString
    End Function

    Public Function StripSpaces(ByVal Input As String) As String
        Return Replace(Input, " ", "_")
    End Function
#End Region

End Module

Public Class PrinterMonitorViewerApplication
#Region "Application trace switch"
    Public Shared ApplicationTracing As New System.Diagnostics.TraceSwitch("Application", "Printer Watch Viewer application tracing")
#End Region

End Class