Imports System.Data.SqlClient

'\\ --[PumaSettings]-----------------------------------------------
'\\ The application global settings which are held centrally in the
'\\ PrintMonitor database
'\\ (c) 2005 - Merrion Computing Ltd
'\\ ---------------------------------------------------------------
Public Class PumaSettings

#Region "Private constants"
    Private Const SETTINGS_TABLE = "[PUMA Parameters]"
#End Region

#Region "Private properties"
    Private _DBConn As SqlConnection
    Private _Settings As Collection
#End Region

#Region "Public interface"
#Region "SettingExists"
    '\\ --[SettingExists]------------------------------------------------
    '\\ Returns TRUE if the setting named exists
    '\\ -----------------------------------------------------------------
    Public Function SettingExists(ByVal SettingName As String) As Boolean
        If Not _Settings Is Nothing Then
            Try
                If Not (_Settings.Item(SettingName) Is Nothing) Then
                    Return True
                End If
            Catch ex As Exception
                Return False
            End Try
        End If
    End Function
#End Region

#Region "SettingValue"
    Public Function SettingValue(ByVal SettingName As String) As String
        If SettingExists(SettingName) Then
            Return _Settings.Item(SettingName)
        End If
    End Function
#End Region
#End Region

#Region "Public constructor"
    Public Sub New(ByVal ConnectionString As String)

        Try
            _DBConn = New SqlConnection(ConnectionString)
        Catch ex As Exception
            If PrinterMonitorViewerApplication.ApplicationTracing.TraceError Then
                Trace.WriteLine(ex.ToString, Me.GetType.ToString & " (constructor)")
            End If
            '\\ Pass the error on to the system debugger
            Throw
        End Try

        '\\ Populate the dictionary from the table
        If _DBConn.State = ConnectionState.Closed Then
            _DBConn.Open()
        End If

        Dim sqlCmd As New SqlCommand("SELECT * FROM " & SETTINGS_TABLE, _DBConn)
        Dim sqlSettings As SqlDataReader = sqlCmd.ExecuteReader
        _Settings = New Collection
        While sqlSettings.Read
            _Settings.Add(sqlSettings.GetString(1), sqlSettings.GetString(0))
        End While
        sqlSettings.Close()

    End Sub
#End Region

End Class
