'\\ --[PrintJobMonitorListenerBase]------------------------
'\\ Base class for listeners that respond to the printer
'\\ monitoring service job events
'\\ ------------------------------------------------------
Public MustInherit Class PrintJobMonitorListenerBase

#Region "Command line startup parameters"
    Public MustOverride WriteOnly Property CommandLine() As String
#End Region

#Region "Print Job related events"
#Region "OnJobAdded"
    Public MustOverride Sub OnJobAdded(ByVal PrinterName As String, ByVal Username As String, ByVal Document As String, ByVal Machinename As String, ByVal Pages As Integer, ByVal Copies As Integer, ByVal Submitted As DateTime, ByVal PaperType As String, _
                                       ByVal Landscape As Boolean, ByVal Colour As Boolean, _
                                       ByVal PaperSource As String, ByVal PrinterResolution As String, _
                                       ByVal Paused As Boolean, ByVal Deleted As Boolean, ByVal Deleting As Boolean, _
                                       ByVal Printed As Boolean, ByVal Printing As Boolean, _
                                       ByVal InError As Boolean, ByVal Offline As Boolean, _
                                       ByVal PaperOut As Boolean, ByVal UserInterventionRequired As Boolean, _
                                       ByVal DataType As String, _
                                       ByVal PaperWidth As Integer, _
                                       ByVal PaperHeight As Integer, _
                                       ByVal PrinterResolutionX As Integer, _
                                       ByVal PrinterResolutionY As Integer, _
                                       ByVal NotifyUserName As String, _
                                       ByVal PrintProcessorName As String, _
                                       ByVal DriverName As String, _
                                       ByVal Parameters As String, _
                                       ByVal QueuedTime As Integer, _
                                       ByVal JobSize As Integer, _
                                       ByVal JobId As Integer)

#End Region
#Region "OnJobDeleted"
    Public MustOverride Sub OnJobDeleted(ByVal PrinterName As String, ByVal Username As String, ByVal Document As String, ByVal Machinename As String, ByVal Pages As Integer, ByVal Copies As Integer, ByVal Submitted As DateTime, ByVal Status As String, ByVal PagesPrinted As Integer, _
                                         ByVal Paused As Boolean, ByVal Deleted As Boolean, ByVal Deleting As Boolean, _
                                         ByVal Printed As Boolean, ByVal Printing As Boolean, _
                                         ByVal InError As Boolean, ByVal Offline As Boolean, _
                                         ByVal PaperOut As Boolean, ByVal UserInterventionRequired As Boolean, _
                                         ByVal QueuedTime As Integer, ByVal JobSize As Integer, ByVal JobId As Integer)

#End Region
#Region "OnJobSet"
    Public MustOverride Sub OnJobSet(ByVal PrinterName As String, ByVal Username As String, ByVal Document As String, ByVal Machinename As String, ByVal Pages As Integer, ByVal Copies As Integer, ByVal Submitted As DateTime, ByVal Status As String, ByVal PagesPrinted As Integer, _
                                  ByVal Paused As Boolean, ByVal Deleted As Boolean, ByVal Deleting As Boolean, _
                                  ByVal Printed As Boolean, ByVal Printing As Boolean, _
                                  ByVal InError As Boolean, ByVal Offline As Boolean, _
                                  ByVal PaperOut As Boolean, ByVal UserInterventionRequired As Boolean, _
                                  ByVal QueuedTime As Integer, ByVal JobSize As Integer, ByVal JobId As Integer)

#End Region
#Region "OnJobWritten"
    Public MustOverride Sub OnJobWritten(ByVal PrinterName As String, ByVal Username As String, ByVal Document As String, ByVal Machinename As String, ByVal Pages As Integer, ByVal Copies As Integer, ByVal Submitted As DateTime, ByVal Status As String, ByVal PagesPrinted As Integer, _
                                     ByVal Paused As Boolean, ByVal Deleted As Boolean, ByVal Deleting As Boolean, _
                                     ByVal Printed As Boolean, ByVal Printing As Boolean, _
                                     ByVal InError As Boolean, ByVal Offline As Boolean, _
                                     ByVal PaperOut As Boolean, ByVal UserInterventionRequired As Boolean, _
                                     ByVal QueuedTime As Integer, ByVal JobSize As Integer, ByVal JobId As Integer)

#End Region
#End Region

#Region "Service events"
    Public MustOverride Sub OnStopService()
#End Region

End Class

'\\ --[PrinterMonitorListenerBase]------------------------
'\\ Base class for listeners that respond to the printer
'\\ monitoring service printer information events
'\\ ------------------------------------------------------
Public MustInherit Class PrinterMonitorListenerBase

#Region "Command line startup parameters"
    Public MustOverride WriteOnly Property CommandLine() As String
#End Region

#Region "Printer information related events"
#Region "OnPrinterInformationChanged"
    Public MustOverride Sub OnPrinterInformationChanged(ByVal PrinterName As String, ByVal Location As String, ByVal Comment As String, ByVal JobCount As Integer, _
        ByVal IsReady As Boolean, ByVal IsDoorOpen As Boolean, _
        ByVal IsInError As Boolean, ByVal IsInitialising As Boolean, _
        ByVal IsAwaitingManualFeed As Boolean, ByVal IsOutOfToner As Boolean, _
        ByVal IsUnavailable As Boolean, ByVal IsOffline As Boolean, _
        ByVal IsOutOfMemory As Boolean, ByVal IsOutputBinFull As Boolean, _
        ByVal IsPaperJammed As Boolean, ByVal IsOutOfPaper As Boolean, _
        ByVal IsPaused As Boolean, ByVal IsDeletingJob As Boolean, _
        ByVal IsInPowerSave As Boolean, ByVal IsPrinting As Boolean, _
        ByVal IsWaitingOnUserIntervention As Boolean, ByVal IsWarmingUp As Boolean, _
        ByVal ServerName As String, _
        ByVal ShareName As String, _
        ByVal PortName As String, _
        ByVal DriverName As String, _
        ByVal SeperatorFilename As String, _
        ByVal PrintProcessor As String, _
        ByVal DefaultDataType As String, _
        ByVal Parameters As String)


#End Region
#End Region

#Region "Service events"
    Public MustOverride Sub OnStopService()
#End Region

End Class