'\\ --[PrintWatchTestApplicationSettings]--------------------
'\\ A class for reading and writing the application settings
'\\ for the PrintWatchTest application
'\\ (c) 2003 - Merrion Computing Ltd
'\\ ---------------------------------------------------------
Imports System.Collections
Imports PrinterQueueWatch

Public Class PrinterMonitorServiceSettings

#Region "Private member variables"

    '\\ -- Printer Monitoring Global Settings
    Private _MonitorJobEventInformationLevel As Integer
    Private _MonitorPrinterChangeEvent As Boolean = True
    Private _MonitorJobAddedEvent As Boolean = True
    Private _MonitorDeletedEvent As Boolean = True
    Private _MonitorJobSetEvent As Boolean = True
    Private _MonitorJobWrittenEvent As Boolean = True

    Private _ReadSettingsFromDB As Boolean = True
    Private _ConnectionString As String = "Persist Security Info=False;Integrated Security=SSPI;database=PrintMonitor;server=(local);Connect Timeout=30"

    Private _ShowIcon As Boolean = False

    '\\ -- Application tracing settings
    Private _PrinterMonitorComponentTraceLevel As System.Diagnostics.TraceLevel = TraceLevel.Error
    Private _ApplicationTraceLevel As System.Diagnostics.TraceLevel = TraceLevel.Error


    '\\ -- Class state
    Private _Changed As Boolean

#End Region

#Region "Public properties"
    Public Property MonitorJobEventInformationLevel() As PrinterQueueWatch.PrinterMonitorComponent.MonitorJobEventInformationLevels
        Get
            Return CType(_MonitorJobEventInformationLevel, PrinterQueueWatch.PrinterMonitorComponent.MonitorJobEventInformationLevels)
        End Get
        Set(ByVal Value As PrinterQueueWatch.PrinterMonitorComponent.MonitorJobEventInformationLevels)
            _MonitorJobEventInformationLevel = Value
            _Changed = True
        End Set
    End Property

    Public Property MonitorPrinterChangeEvent() As Boolean
        Get
            Return _MonitorPrinterChangeEvent
        End Get
        Set(ByVal Value As Boolean)
            _MonitorPrinterChangeEvent = Value
            _Changed = True
        End Set
    End Property

    Public Property MonitorJobAddedEvent() As Boolean
        Get
            Return _MonitorJobAddedEvent
        End Get
        Set(ByVal Value As Boolean)
            _MonitorJobAddedEvent = Value
            _Changed = True
        End Set
    End Property

    Public Property MonitorDeletedEvent() As Boolean
        Get
            Return _MonitorDeletedEvent
        End Get
        Set(ByVal Value As Boolean)
            _MonitorDeletedEvent = Value
            _Changed = True
        End Set
    End Property

    Public Property MonitorJobSetEvent() As Boolean
        Get
            Return _MonitorJobSetEvent
        End Get
        Set(ByVal Value As Boolean)
            _MonitorJobSetEvent = Value
            _Changed = True
        End Set
    End Property

    Public Property MonitorJobWrittenEvent() As Boolean
        Get
            Return _MonitorJobWrittenEvent
        End Get
        Set(ByVal Value As Boolean)
            _MonitorJobWrittenEvent = Value
            _Changed = True
        End Set
    End Property

    Public Property ReadSettingsFromDB() As Boolean
        Get
            Return _ReadSettingsFromDB
        End Get
        Set(ByVal Value As Boolean)
            _ReadSettingsFromDB = True
            _Changed = True
        End Set
    End Property

    Public ReadOnly Property ShowIcon() As Boolean
        Get
            Return _ShowIcon
        End Get
    End Property

    Public ReadOnly Property ConnectionString() As String
        Get
            Return _ConnectionString
        End Get
    End Property

    Public ReadOnly Property Changed() As Boolean
        Get
            Return _Changed
        End Get
    End Property

#End Region

#Region "Public methods"
    Public Sub ReadSettings()
        Dim configSettings As New System.Configuration.AppSettingsReader()

        Try
            With configSettings
                _MonitorJobEventInformationLevel = CType([Enum].Parse(GetType(PrinterQueueWatch.PrinterMonitorComponent.MonitorJobEventInformationLevels), DirectCast(.GetValue("MonitorJobEventInformationLevel", GetType(System.String)), String)), PrinterQueueWatch.PrinterMonitorComponent.MonitorJobEventInformationLevels)
                _MonitorPrinterChangeEvent = DirectCast(.GetValue("MonitorPrinterChangeEvent", GetType(System.Boolean)), Boolean)
                _MonitorJobAddedEvent = DirectCast(.GetValue("MonitorJobAddedEvent", GetType(System.Boolean)), Boolean)
                _MonitorDeletedEvent = DirectCast(.GetValue("MonitorDeletedEvent", GetType(System.Boolean)), Boolean)
                _MonitorJobSetEvent = DirectCast(.GetValue("MonitorJobSetEvent", GetType(System.Boolean)), Boolean)
                _MonitorJobWrittenEvent = DirectCast(.GetValue("MonitorJobWrittenEvent", GetType(System.Boolean)), Boolean)
                _ReadSettingsFromDB = DirectCast(.GetValue("ReadSettingsFromDB", GetType(System.Boolean)), Boolean)
                _ConnectionString = DirectCast(.GetValue("ConnectionString", GetType(System.String)), String)
                _ShowIcon = DirectCast(.GetValue("ShowIcon", GetType(System.Boolean)), Boolean)
            End With
        Catch e As Exception
            If PrinterMonitoringService.ApplicationTracing.TraceError Then
                Trace.WriteLine(e.ToString)
            End If
        End Try

    End Sub

    Public Sub SaveSettings()
        If _Changed Then
            '\\ Todo: save the service settings here...
        End If
    End Sub

#End Region

#Region "Public constructor"
    Public Sub New()
        '\\ Read in the settings for this application
        Call ReadSettings()
    End Sub
#End Region

End Class
